#include "BluetoothSerial.h"
#include "AccelStepper.h"

BluetoothSerial SerialBT;
const int LED = 23;
int Incoming_value = 0, m = 0, wSpeed = 100 ;

AccelStepper firstWheel(1, 16, 4);   // (Type:driver, STEP, DIR) - Stepper1
AccelStepper secondWheel(1, 5, 17);   // (Type:driver, STEP, DIR) - Stepper2
AccelStepper thirdWheel(1, 19, 18);   // (Type:driver, STEP, DIR) - Stepper3
AccelStepper elevator(1, 26, 25);   // (Type:driver, STEP, DIR) - Stepper4

void setup() {
  Serial.begin(115200);
  Serial.println("ESP32 started");
  SerialBT.begin("ESP32test"); //Bluetooth device name
  Serial.println("The device started, now you can pair it with bluetooth!");

  firstWheel.setMaxSpeed(1000);
  firstWheel.setSpeed(0); 
  secondWheel.setMaxSpeed(1000);
  secondWheel.setSpeed(0);
  thirdWheel.setMaxSpeed(1000);
  thirdWheel.setSpeed(0);
  elevator.setMaxSpeed(3000);
  elevator.setSpeed(0);

}

void loop() {
  
  if (SerialBT.available()) {
    Incoming_value = SerialBT.read();   

//Get value from Bluetooth Radio
    if(Incoming_value == 1){             
      m = 1;
    }
    if(Incoming_value == 2){             
      m = 2;
    }
    if(Incoming_value == 3){             
      m = 3;
    }
    if(Incoming_value == 4){             
      m = 4;
    }
    if(Incoming_value == 5){             
      m = 5;
    }
    if(Incoming_value == 6){             
      m = 6;
    }
    if(Incoming_value == 7){             
      m = 7;
    }
    if(Incoming_value == 8){             
      m = 8;
    }
    if(Incoming_value == 9){             
      m = 9;
    }
    if(Incoming_value == 10){             
      m = 10;
    }
    else if(Incoming_value == 11){
      m = 11; 
    }  
    else if(Incoming_value == 12){
      m = 12;
    }   
    else if(Incoming_value == 0){
      m = 0;           
    }
    Serial.println(Incoming_value);   
    if (Incoming_value >= 16) {
      wSpeed = Incoming_value;
      Serial.println(wSpeed);
    }     
  }


//Set a motor speed
  //wSpeed=50;
  
  if (m == 1){
      digitalWrite(LED, HIGH);
      leftForward();   
  }
  if (m == 2){
      digitalWrite(LED, HIGH);
      forward();   
  }
  if (m == 3){
      digitalWrite(LED, HIGH);
      rightForward();   
  }
  if (m == 4){
      digitalWrite(LED, HIGH);
      left();   
  }
  if (m == 5){
      digitalWrite(LED, HIGH);
      right();   
  }
  if (m == 6){
      digitalWrite(LED, HIGH);
      leftBackward();   
  }
  if (m == 7){
      digitalWrite(LED, HIGH);
      backward();   
  }
  if (m == 8){
      digitalWrite(LED, HIGH);
      rightBackward();   
  }
  if (m == 9){
      digitalWrite(LED, HIGH);
      rotateLeft();   
  }
  if (m == 10){
      digitalWrite(LED, HIGH);
      rotateRight();   
  }
  else if (m == 11){
      digitalWrite(LED, HIGH);
      elevatorUp();
  }
  else if (m == 12){
      digitalWrite(LED, HIGH);
      elevatorDown();

  }
  else if (m == 0){
      digitalWrite(LED, LOW);
      stopMoving(); 
  }


  delay(10);
  //run motor physically
  firstWheel.runSpeed();
  secondWheel.runSpeed();
  thirdWheel.runSpeed();
  elevator.runSpeed();
  
}

void forward(){
  firstWheel.setSpeed(0);
  secondWheel.setSpeed(wSpeed*-0.87);
  thirdWheel.setSpeed(wSpeed*0.87);
  elevator.setSpeed(0); 
}
void backward(){
  firstWheel.setSpeed(0);
  secondWheel.setSpeed(wSpeed*0.87);
  thirdWheel.setSpeed(wSpeed*-0.87);
  elevator.setSpeed(0); 
}
void left(){
  firstWheel.setSpeed(wSpeed);
  secondWheel.setSpeed(wSpeed*-0.4);
  thirdWheel.setSpeed(wSpeed*-0.6);
  elevator.setSpeed(0); 
}
void right(){
  firstWheel.setSpeed(wSpeed*-1);
  secondWheel.setSpeed(wSpeed*0.5);
  thirdWheel.setSpeed(wSpeed*0.5);
  elevator.setSpeed(0); 
}

void rightForward(){
  firstWheel.setSpeed(wSpeed*-1);
  secondWheel.setSpeed(wSpeed*-0.37);
  thirdWheel.setSpeed(wSpeed*1.37);
  elevator.setSpeed(0); 
}
void leftForward(){
  firstWheel.setSpeed(wSpeed);
  secondWheel.setSpeed(wSpeed*-1.37);
  thirdWheel.setSpeed(wSpeed*-0.37);
  elevator.setSpeed(0); 
}
void leftBackward(){
  firstWheel.setSpeed(wSpeed);
  secondWheel.setSpeed(wSpeed*-1.37);
  thirdWheel.setSpeed(wSpeed*0.37);
  elevator.setSpeed(0); 
}
void rightBackward(){
  firstWheel.setSpeed(wSpeed*-1);
  secondWheel.setSpeed(wSpeed*0.37);
  thirdWheel.setSpeed(wSpeed*-1.37);
  elevator.setSpeed(0); 
}


void rotateLeft(){
  firstWheel.setSpeed(wSpeed);
  secondWheel.setSpeed(wSpeed);
  thirdWheel.setSpeed(wSpeed);
  elevator.setSpeed(0); 
}
void rotateRight(){
  firstWheel.setSpeed(-1*wSpeed);
  secondWheel.setSpeed(-1*wSpeed);
  thirdWheel.setSpeed(-1*wSpeed);
  elevator.setSpeed(0); 
}

void elevatorUp(){
  firstWheel.setSpeed(0);
  secondWheel.setSpeed(0);
  thirdWheel.setSpeed(0);
  elevator.setSpeed(-2000); 
}

void elevatorDown(){
  firstWheel.setSpeed(0);
  secondWheel.setSpeed(0);
  thirdWheel.setSpeed(0);
  elevator.setSpeed(2000); 
}


void stopMoving() {
  firstWheel.setSpeed(0);
  secondWheel.setSpeed(0);
  thirdWheel.setSpeed(0);
  elevator.setSpeed(0);
}
